searchNodes=[{"doc":"JSON Schema A JSON schema parser for inspection and manipulation of JSON Schema Abstract Syntax Trees (ASTs). This library is meant as a basis for writing other libraries or tools that need to use JSON schema documents. For example, a JSON schema validator that validates a JSON object according to a JSON schema specification, or a code generator that generates a data model and accompanying JSON serializers based on the JSON schema specification of an API -- the project JSON Schema to Elm is an example of such a tool. Installation Add :json_schema as a dependency in mix.exs : defp deps do [ { :json_schema , &quot;~&gt; 0.4&quot; } ] end Usage The words type and subschema are used interchangeable in the rest of the document. The main API entry point is the JsonSchema module, which supports parsing a list of JSON schema files into JSON Schema ASTs via parse_schema_files , or resolving a JSON schema type given an identifier via resolve_type . Parsing a JSON schema file into an Abstract Syntax Tree Presuming we have the following two JSON schema files: { &quot;$schema&quot;: &quot;http://json-schema.org/draft-07/schema#&quot;, &quot;$id&quot;: &quot;http://example.com/circle.json&quot;, &quot;title&quot;: &quot;Circle&quot;, &quot;description&quot;: &quot;Schema for a circle shape&quot;, &quot;type&quot;: &quot;object&quot;, &quot;properties&quot;: { &quot;center&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#point&quot; }, &quot;radius&quot;: { &quot;type&quot;: &quot;number&quot; }, &quot;color&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#color&quot; } }, &quot;required&quot;: [&quot;center&quot;, &quot;radius&quot;] } and { &quot;$schema&quot;: &quot;http://json-schema.org/draft-07/schema#&quot;, &quot;title&quot;: &quot;Definitions&quot;, &quot;$id&quot;: &quot;http://example.com/definitions.json&quot;, &quot;description&quot;: &quot;Schema for common types&quot;, &quot;definitions&quot;: { &quot;color&quot;: { &quot;$id&quot;: &quot;#color&quot;, &quot;type&quot;: &quot;string&quot;, &quot;enum&quot;: [ &quot;red&quot;, &quot;yellow&quot;, &quot;green&quot;, &quot;blue&quot; ] }, &quot;point&quot;: { &quot;$id&quot;: &quot;#point&quot;, &quot;type&quot;: &quot;object&quot;, &quot;properties&quot;: { &quot;x&quot;: { &quot;type&quot;: &quot;number&quot; }, &quot;y&quot;: { &quot;type&quot;: &quot;number&quot; } }, &quot;required&quot;: [ &quot;x&quot;, &quot;y&quot; ] } } } we can parses the into a JSON schema AST by passing them to JsonSchema.parse_schema_files . This produces a SchemaResult containing a schema dictionary, schema_dict , and any errors or warnings generated along the way. schema_paths = [ &quot;./path/to/json_schemas/circle.json&quot; , &quot;./path/to/json_schemas/definitions.json&quot; ] schema_result = JsonSchema . parse_schema_files ( schema_paths ) % JsonSchema.Parser.SchemaResult { errors : [ ] , warnings : [ ] , schema_dict : %{ &quot;http://example.com/circle.json&quot; =&gt; % JsonSchema.Types.SchemaDefinition { description : &quot;Schema for a circle shape&quot; , file_path : &quot;/path/to/json-schemas/circle.json&quot; , id : URI . parse ( &quot;http://example.com/circle.json&quot; ) , title : &quot;Circle&quot; , types : %{ &quot;#&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : &quot;Schema for a circle shape&quot; , name : &quot;Circle&quot; , path : URI . parse ( &quot;#&quot; ) , pattern_properties : %{ } , properties : %{ &quot;center&quot; =&gt; URI . parse ( &quot;#/properties/center&quot; ) , &quot;color&quot; =&gt; URI . parse ( &quot;#/properties/color&quot; ) , &quot;radius&quot; =&gt; URI . parse ( &quot;#/properties/radius&quot; ) } , required : [ &quot;center&quot; , &quot;radius&quot; ] } , &quot;#/properties/center&quot; =&gt; % JsonSchema.Types.TypeReference { name : &quot;center&quot; , path : URI . parse ( &quot;http://example.com/definitions.json#point&quot; ) } , &quot;#/properties/color&quot; =&gt; % JsonSchema.Types.TypeReference { name : &quot;color&quot; , path : URI . parse ( &quot;http://example.com/definitions.json#color&quot; ) } , &quot;#/properties/radius&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;radius&quot; , path : URI . parse ( &quot;#/properties/radius), type: :number }, &quot; http :// example . com / circle . json #&quot; =&gt; %JsonSchema.Types.ObjectType{ additional_properties : nil , description : &quot;Schema for a circle shape&quot; , name : &quot;Circle&quot; , path : URI . parse ( &quot;#&quot; ) , pattern_properties : %{ } , properties : %{ &quot;center&quot; =&gt; URI . parse ( &quot;#/properties/center&quot; ) , &quot;color&quot; =&gt; URI . parse ( &quot;#/properties/color&quot; ) , &quot;radius&quot; =&gt; URI . parse ( &quot;#/properties/radius&quot; ) } , required : [ &quot;center&quot; , &quot;radius&quot; ] } } } , &quot;http://example.com/definitions.json&quot; =&gt; % JsonSchema.Types.SchemaDefinition { description : &quot;Schema for common types&quot; , file_path : &quot;/path/to/json-schemas/definitions.json&quot; , id : URI . parse ( &quot;http://example.com/definitions.json&quot; ) , title : &quot;Definitions&quot; , types : %{ &quot;#/definitions/color&quot; =&gt; % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] } , &quot;#/definitions/point&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : nil , name : &quot;point&quot; , path : URI . parse ( &quot;#/definitions/point&quot; ) , pattern_properties : %{ } , properties : %{ &quot;x&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/x&quot; ) , &quot;y&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/y&quot; ) } , required : [ &quot;x&quot; , &quot;y&quot; ] } , &quot;#/definitions/point/properties/x&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;x&quot; , path : URI . parse ( &quot;/definitions/point/properties/x&quot; ) , type : :number } , &quot;#/definitions/point/properties/y&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;y&quot; , path : URI . parse ( &quot;#/definitions/point/properties/y&quot; ) , type : :number } , &quot;http://example.com/definitions.json#color&quot; =&gt; % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] } , &quot;http://example.com/definitions.json#point&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : nil , name : &quot;point&quot; , path : URI . parse ( &quot;#/definitions/point&quot; ) , pattern_properties : %{ } , properties : %{ &quot;x&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/x&quot; ) , &quot;y&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/y&quot; ) } , required : [ &quot;x&quot; , &quot;y&quot; ] } } } } } The schema dictionary uses the schema ID ( URI ) as key and the parsed schema as value. Each parsed schema likewise contains a type dictionary, types , which uses the subschema path ( URI ) as key and the parsed subschema as value. If there are no errors in the schema result, the parsed schema dictionary can then be used in your own JSON schema tool as appropriate. Resolving a JSON Schema type from an identifier Using the example schema dictionary from the previous section, we can use the JsonSchema.resolve_type function to lookup a subschema associated contained the schema dictionary. The resolve_type function expects: the identifier of the subschema to lookup which can be either a fully qualified identifier like http://example.com/definitions.json#color , a relative identifier like #color , or a relative path like #/definitions/color when resolving a subschema inside the same parent schema. the parent identifier of the subschema doing the lookup, needed for relative lookups and better error messaging, the enclosing schema definition, schema_def , of the subschema doing the lookup, also needed for relative lookups and error messaging, the schema dictionary of the whole set of schemas. In the example below, we resolve the reference to color : &quot;color&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#color&quot; } from the inside the circle subschema properties. schema_dict = schema_result . schema_dict schema_def = schema_dict [ &quot;http://example.com/circle.json&quot; ] parent = URI . parse ( &quot;#/properties&quot; ) identifier = URI . parse ( &quot;#/properties/color&quot; ) lookup_result = JsonSchema . resolve_type ( identifier , parent , schema_def , schema_dict ) { :ok , { color_type , parent_schema_def } } = lookup_result parent_schema_def == schema_dict [ &quot;http://example.com/circle.json&quot; ] color_type % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] }","ref":"JsonSchema.html","title":"JsonSchema","type":"module"},{"doc":"Parses a single JSON Schema documents into a SchemaResult .","ref":"JsonSchema.html#parse_schema_document/2","title":"JsonSchema.parse_schema_document/2","type":"function"},{"doc":"Parses one or more JSON Schema documents into a SchemaResult .","ref":"JsonSchema.html#parse_schema_documents/1","title":"JsonSchema.parse_schema_documents/1","type":"function"},{"doc":"Parses one or more JSON schema files into a SchemaResult containing a dictionary of parsed schemas represented as Elixir structs and two lists of any warnings or errors encountered while parsing the JSON schema documents.","ref":"JsonSchema.html#parse_schema_files/1","title":"JsonSchema.parse_schema_files/1","type":"function"},{"doc":"Resolves a JSON schema Types.typeIdentifier , when given a SchemaDefinition and a Types.schemaDictionary .","ref":"JsonSchema.html#resolve_type/4","title":"JsonSchema.resolve_type/4","type":"function"},{"doc":"Parses JSON schema files into an intermediate representation to be used for e.g. printing elm decoders.","ref":"JsonSchema.Parser.html","title":"JsonSchema.Parser","type":"module"},{"doc":"Parses a single JSON Schema documents into a SchemaResult .","ref":"JsonSchema.Parser.html#parse_schema_document/2","title":"JsonSchema.Parser.parse_schema_document/2","type":"function"},{"doc":"Parses one or more JSON Schema documents into a SchemaResult .","ref":"JsonSchema.Parser.html#parse_schema_documents/1","title":"JsonSchema.Parser.parse_schema_documents/1","type":"function"},{"doc":"Parses one or more JSON Schema files into a SchemaResult .","ref":"JsonSchema.Parser.html#parse_schema_files/1","title":"JsonSchema.Parser.parse_schema_files/1","type":"function"},{"doc":"Parses a JSON schema allOf type: { &quot;allOf&quot; : [ { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/color&quot; } , &quot;title&quot; : { &quot;type&quot; : &quot;string&quot; } , &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;color&quot; , &quot;radius&quot; ] } , { &quot;type&quot; : &quot;string&quot; } ] } Into an JsonSchema.Types.AllOfType .","ref":"JsonSchema.Parser.AllOfParser.html","title":"JsonSchema.Parser.AllOfParser","type":"module"},{"doc":"Parses a JSON schema allOf type into an JsonSchema.Types.AllOfType .","ref":"JsonSchema.Parser.AllOfParser.html#parse/5","title":"JsonSchema.Parser.AllOfParser.parse/5","type":"function"},{"doc":"Returns true if the JSON subschema represents an allOf type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;allOf&quot; =&gt; []}) false iex&gt; type?(%{&quot;allOf&quot; =&gt; [%{&quot;$ref&quot; =&gt; &quot;#foo&quot;}]}) true","ref":"JsonSchema.Parser.AllOfParser.html#type?/1","title":"JsonSchema.Parser.AllOfParser.type?/1","type":"function"},{"doc":"Parses a JSON schema anyOf type: { &quot;anyOf&quot; : [ { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/color&quot; } , &quot;title&quot; : { &quot;type&quot; : &quot;string&quot; } , &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;color&quot; , &quot;radius&quot; ] } , { &quot;type&quot; : &quot;string&quot; } ] } Into an JsonSchema.Types.AnyOfType .","ref":"JsonSchema.Parser.AnyOfParser.html","title":"JsonSchema.Parser.AnyOfParser","type":"module"},{"doc":"Parses a JSON schema anyOf type into an JsonSchema.Types.AnyOfType .","ref":"JsonSchema.Parser.AnyOfParser.html#parse/5","title":"JsonSchema.Parser.AnyOfParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an anyOf type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;anyOf&quot; =&gt; []}) false iex&gt; type?(%{&quot;anyOf&quot; =&gt; [%{&quot;$ref&quot; =&gt; &quot;#foo&quot;}]}) true","ref":"JsonSchema.Parser.AnyOfParser.html#type?/1","title":"JsonSchema.Parser.AnyOfParser.type?/1","type":"function"},{"doc":"Parses a JSON schema array type: { &quot;type&quot; : &quot;array&quot; , &quot;items&quot; : { &quot;$ref&quot; : &quot;#/definitions/rectangle&quot; } } Into an JsonSchema.Types.ArrayType .","ref":"JsonSchema.Parser.ArrayParser.html","title":"JsonSchema.Parser.ArrayParser","type":"module"},{"doc":"Parses a JSON schema array type into an JsonSchema.Types.ArrayType .","ref":"JsonSchema.Parser.ArrayParser.html#parse/5","title":"JsonSchema.Parser.ArrayParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an array type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;items&quot; =&gt; %{&quot;$ref&quot; =&gt; &quot;#foo&quot;}}) true","ref":"JsonSchema.Parser.ArrayParser.html#type?/1","title":"JsonSchema.Parser.ArrayParser.type?/1","type":"function"},{"doc":"Parse a JSON schema const type: { &quot;type&quot; : &quot;string&quot; , &quot;const&quot; : &quot;This is a constant&quot; } Into an JsonSchema.Types.ConstType .","ref":"JsonSchema.Parser.ConstParser.html","title":"JsonSchema.Parser.ConstParser","type":"module"},{"doc":"Parses a JSON schema const type into an JsonSchema.Types.ConstType .","ref":"JsonSchema.Parser.ConstParser.html#parse/5","title":"JsonSchema.Parser.ConstParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an const type. Examples iex&gt; type? ( %{ } ) false iex&gt; type? ( %{ &quot;const&quot; =&gt; nil } ) true iex&gt; type? ( %{ &quot;const&quot; =&gt; false } ) true iex&gt; type? ( %{ &quot;const&quot; =&gt; &quot;23.4&quot; } ) true iex&gt; type? ( %{ &quot;const&quot; =&gt; &quot;This is a constant&quot; } ) true iex&gt; type? ( %{ &quot;const&quot; =&gt; %{ &quot;foo&quot; =&gt; 42 } } ) true","ref":"JsonSchema.Parser.ConstParser.html#type?/1","title":"JsonSchema.Parser.ConstParser.type?/1","type":"function"},{"doc":"Parses a 'definitions' property in a JSON schema or subschema. { &quot;$schema&quot; : &quot;http://json-schema.org/draft-04/schema#&quot; , &quot;id&quot; : &quot;http://example.com/root.json&quot; , &quot;definitions&quot; : { &quot;foo&quot; : { ... } , &quot;bar&quot; : { ... } } } Into a type dictionary.","ref":"JsonSchema.Parser.DefinitionsParser.html","title":"JsonSchema.Parser.DefinitionsParser","type":"module"},{"doc":"Parses a JSON schema 'definitions' property into a map of types.","ref":"JsonSchema.Parser.DefinitionsParser.html#parse/5","title":"JsonSchema.Parser.DefinitionsParser.parse/5","type":"function"},{"doc":"Returns true if the json schema contains a 'definitions' property. Examples iex&gt; type?(%{&quot;title&quot; =&gt; &quot;A fancy title&quot;}) false iex&gt; type?(%{&quot;definitions&quot; =&gt; %{}}) true","ref":"JsonSchema.Parser.DefinitionsParser.html#type?/1","title":"JsonSchema.Parser.DefinitionsParser.type?/1","type":"function"},{"doc":"Parse a JSON schema enum type: { &quot;type&quot; : &quot;string&quot; , &quot;enum&quot; : [ &quot;none&quot; , &quot;green&quot; , &quot;orange&quot; , &quot;blue&quot; , &quot;yellow&quot; , &quot;red&quot; ] } Into an JsonSchema.Types.EnumType .","ref":"JsonSchema.Parser.EnumParser.html","title":"JsonSchema.Parser.EnumParser","type":"module"},{"doc":"Parses a JSON schema enum type into an JsonSchema.Types.EnumType .","ref":"JsonSchema.Parser.EnumParser.html#parse/5","title":"JsonSchema.Parser.EnumParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an enum type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;enum&quot; =&gt; [&quot;red&quot;, &quot;yellow&quot;, &quot;green&quot;], &quot;type&quot; =&gt; &quot;string&quot;}) true","ref":"JsonSchema.Parser.EnumParser.html#type?/1","title":"JsonSchema.Parser.EnumParser.type?/1","type":"function"},{"doc":"Contains helper functions for reporting parser errors.","ref":"JsonSchema.Parser.ErrorUtil.html","title":"JsonSchema.Parser.ErrorUtil","type":"module"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#could_not_read_file/1","title":"JsonSchema.Parser.ErrorUtil.could_not_read_file/1","type":"function"},{"doc":"Returns the name of the type of the given value. Examples iex&gt; get_type ( [ 1 , 2 , 3 ] ) &quot;list&quot; iex&gt; get_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) &quot;object&quot; iex&gt; get_type ( &quot;name&quot; ) &quot;string&quot; iex&gt; get_type ( 42 ) &quot;integer&quot;","ref":"JsonSchema.Parser.ErrorUtil.html#get_type/1","title":"JsonSchema.Parser.ErrorUtil.get_type/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#invalid_json/2","title":"JsonSchema.Parser.ErrorUtil.invalid_json/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#invalid_type/4","title":"JsonSchema.Parser.ErrorUtil.invalid_type/4","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#invalid_uri/3","title":"JsonSchema.Parser.ErrorUtil.invalid_uri/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#missing_property/2","title":"JsonSchema.Parser.ErrorUtil.missing_property/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#name_collision/1","title":"JsonSchema.Parser.ErrorUtil.name_collision/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#name_not_a_regex/2","title":"JsonSchema.Parser.ErrorUtil.name_not_a_regex/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#schema_name_collision/1","title":"JsonSchema.Parser.ErrorUtil.schema_name_collision/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unexpected_type/2","title":"JsonSchema.Parser.ErrorUtil.unexpected_type/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unknown_enum_type/1","title":"JsonSchema.Parser.ErrorUtil.unknown_enum_type/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unknown_node_type/3","title":"JsonSchema.Parser.ErrorUtil.unknown_node_type/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unknown_primitive_type/1","title":"JsonSchema.Parser.ErrorUtil.unknown_primitive_type/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unknown_type/1","title":"JsonSchema.Parser.ErrorUtil.unknown_type/1","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unknown_union_type/2","title":"JsonSchema.Parser.ErrorUtil.unknown_union_type/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unresolved_reference/2","title":"JsonSchema.Parser.ErrorUtil.unresolved_reference/2","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ErrorUtil.html#unsupported_schema_version/2","title":"JsonSchema.Parser.ErrorUtil.unsupported_schema_version/2","type":"function"},{"doc":"Parses a JSON schema object type: { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/color&quot; } , &quot;title&quot; : { &quot;type&quot; : &quot;string&quot; } , &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;color&quot; , &quot;radius&quot; ] } Into an JsonSchema.Types.ObjectType","ref":"JsonSchema.Parser.ObjectParser.html","title":"JsonSchema.Parser.ObjectParser","type":"module"},{"doc":"Creates a property dictionary based on a type dictionary and a type path. Examples iex&gt; type_dict = %{ } ...&gt; path = URI . parse ( &quot;#&quot; ) ...&gt; id = &quot;http://www.example.com/root.json&quot; ...&gt; JsonSchema.Parser.ObjectParser . create_property_dict ( type_dict , path , id ) %{ }","ref":"JsonSchema.Parser.ObjectParser.html#create_property_dict/3","title":"JsonSchema.Parser.ObjectParser.create_property_dict/3","type":"function"},{"doc":"Parses a JSON schema object type into an JsonSchema.Types.ObjectType .","ref":"JsonSchema.Parser.ObjectParser.html#parse/5","title":"JsonSchema.Parser.ObjectParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an allOf type. Examples iex&gt; type?(%{}) false iex&gt; an_object = %{&quot;properties&quot; =&gt; %{&quot;name&quot; =&gt; %{&quot;type&quot; =&gt; &quot;string&quot;}}} iex&gt; type?(an_object) true","ref":"JsonSchema.Parser.ObjectParser.html#type?/1","title":"JsonSchema.Parser.ObjectParser.type?/1","type":"function"},{"doc":"Parses a JSON schema oneOf type: { &quot;oneOf&quot; : [ { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/color&quot; } , &quot;title&quot; : { &quot;type&quot; : &quot;string&quot; } , &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;color&quot; , &quot;radius&quot; ] } , { &quot;type&quot; : &quot;string&quot; } ] } Into an JsonSchema.Types.OneOfType .","ref":"JsonSchema.Parser.OneOfParser.html","title":"JsonSchema.Parser.OneOfParser","type":"module"},{"doc":"Parses a JSON schema oneOf type into an JsonSchema.Types.OneOfType .","ref":"JsonSchema.Parser.OneOfParser.html#parse/5","title":"JsonSchema.Parser.OneOfParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents an oneOf type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;oneOf&quot; =&gt; []}) false iex&gt; type?(%{&quot;oneOf&quot; =&gt; [%{&quot;$ref&quot; =&gt; &quot;#foo&quot;}]}) true","ref":"JsonSchema.Parser.OneOfParser.html#type?/1","title":"JsonSchema.Parser.OneOfParser.type?/1","type":"function"},{"doc":"Describes the functions needed to implement a parser for a JSON schema node.","ref":"JsonSchema.Parser.ParserBehaviour.html","title":"JsonSchema.Parser.ParserBehaviour","type":"behaviour"},{"doc":"","ref":"JsonSchema.Parser.ParserBehaviour.html#c:parse/5","title":"JsonSchema.Parser.ParserBehaviour.parse/5","type":"callback"},{"doc":"","ref":"JsonSchema.Parser.ParserBehaviour.html#c:type?/1","title":"JsonSchema.Parser.ParserBehaviour.type?/1","type":"callback"},{"doc":"Represents an error generated while parsing a JSON schema object.","ref":"JsonSchema.Parser.ParserError.html","title":"JsonSchema.Parser.ParserError","type":"module"},{"doc":"Constructs a ParserError .","ref":"JsonSchema.Parser.ParserError.html#new/3","title":"JsonSchema.Parser.ParserError.new/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ParserError.html#t:error_type/0","title":"JsonSchema.Parser.ParserError.error_type/0","type":"type"},{"doc":"","ref":"JsonSchema.Parser.ParserError.html#t:t/0","title":"JsonSchema.Parser.ParserError.t/0","type":"type"},{"doc":"Represents the result of parsing a subset of a JSON schema including parsed types, warnings, and errors.","ref":"JsonSchema.Parser.ParserResult.html","title":"JsonSchema.Parser.ParserResult","type":"module"},{"doc":"Merges two ParserResult s and adds any collisions errors from merging their type dictionaries to the list of errors in the merged ParserResult .","ref":"JsonSchema.Parser.ParserResult.html#merge/2","title":"JsonSchema.Parser.ParserResult.merge/2","type":"function"},{"doc":"Returns an empty ParserResult .","ref":"JsonSchema.Parser.ParserResult.html#new/0","title":"JsonSchema.Parser.ParserResult.new/0","type":"function"},{"doc":"Creates a ParserResult from a type dictionary. A ParserResult consists of a type dictionary corresponding to the succesfully parsed part of a JSON schema object, and a list of warnings and errors encountered while parsing.","ref":"JsonSchema.Parser.ParserResult.html#new/3","title":"JsonSchema.Parser.ParserResult.new/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ParserResult.html#t:t/0","title":"JsonSchema.Parser.ParserResult.t/0","type":"type"},{"doc":"Represents a warning generated while parsing a JSON schema object.","ref":"JsonSchema.Parser.ParserWarning.html","title":"JsonSchema.Parser.ParserWarning","type":"module"},{"doc":"Constructs a ParserWarning .","ref":"JsonSchema.Parser.ParserWarning.html#new/3","title":"JsonSchema.Parser.ParserWarning.new/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.ParserWarning.html#t:t/0","title":"JsonSchema.Parser.ParserWarning.t/0","type":"type"},{"doc":"","ref":"JsonSchema.Parser.ParserWarning.html#t:warning_type/0","title":"JsonSchema.Parser.ParserWarning.warning_type/0","type":"type"},{"doc":"Parses a JSON schema primitive type: { &quot;type&quot; : &quot;string&quot; } Into an JsonSchema.Types.PrimitiveType .","ref":"JsonSchema.Parser.PrimitiveParser.html","title":"JsonSchema.Parser.PrimitiveParser","type":"module"},{"doc":"Parses a JSON schema primitive type into an JsonSchema.Types.PrimitiveType .","ref":"JsonSchema.Parser.PrimitiveParser.html#parse/5","title":"JsonSchema.Parser.PrimitiveParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents a primitive type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;type&quot; =&gt; &quot;object&quot;}) false iex&gt; type?(%{&quot;type&quot; =&gt; &quot;boolean&quot;}) true iex&gt; type?(%{&quot;type&quot; =&gt; &quot;integer&quot;}) true","ref":"JsonSchema.Parser.PrimitiveParser.html#type?/1","title":"JsonSchema.Parser.PrimitiveParser.type?/1","type":"function"},{"doc":"Contains logic for verifying the schema version of a JSON schema file.","ref":"JsonSchema.Parser.RootParser.html","title":"JsonSchema.Parser.RootParser","type":"module"},{"doc":"","ref":"JsonSchema.Parser.RootParser.html#parse_schema/2","title":"JsonSchema.Parser.RootParser.parse_schema/2","type":"function"},{"doc":"Parses the ID of a JSON schema. Examples iex&gt; parse_schema_id ( %{ &quot;id&quot; =&gt; &quot;http://www.example.com/my-schema&quot; } ) { :ok , URI . parse ( &quot;http://www.example.com/my-schema&quot; ) } iex&gt; parse_schema_id ( %{ &quot;$id&quot; =&gt; &quot;http://www.example.com/my-schema&quot; } ) { :ok , URI . parse ( &quot;http://www.example.com/my-schema&quot; ) } iex&gt; { :error , error } = parse_schema_id ( %{ &quot;id&quot; =&gt; &quot;foo bar baz&quot; } ) iex&gt; error . error_type :invalid_uri iex&gt; { :error , error } = parse_schema_id ( %{ } ) iex&gt; error . error_type :missing_property","ref":"JsonSchema.Parser.RootParser.html#parse_schema_id/1","title":"JsonSchema.Parser.RootParser.parse_schema_id/1","type":"function"},{"doc":"Returns :ok if the given JSON schema has a known supported version, and an error tuple otherwise. Examples iex&gt; schema = %{ &quot;$schema&quot; =&gt; &quot;http://json-schema.org/draft-07/schema#&quot; } iex&gt; parse_schema_version ( schema ) { :ok , &quot;http://json-schema.org/draft-07/schema#&quot; } iex&gt; schema = %{ &quot;$schema&quot; =&gt; &quot;http://example.org/my-own-schema&quot; } iex&gt; { :error , error } = parse_schema_version ( schema ) iex&gt; error . error_type :unsupported_schema_version iex&gt; { :error , error } = parse_schema_version ( %{ } ) iex&gt; error . error_type :missing_property","ref":"JsonSchema.Parser.RootParser.html#parse_schema_version/1","title":"JsonSchema.Parser.RootParser.parse_schema_version/1","type":"function"},{"doc":"Represents the result of parsing a whole JSON schema including the parsed schema, along with all warnings and errors generated while parsing the schema and its members.","ref":"JsonSchema.Parser.SchemaResult.html","title":"JsonSchema.Parser.SchemaResult","type":"module"},{"doc":"Merges two SchemaResult s and adds any collisions errors from merging their schema dictionaries to the list of errors in the merged SchemaResult .","ref":"JsonSchema.Parser.SchemaResult.html#merge/2","title":"JsonSchema.Parser.SchemaResult.merge/2","type":"function"},{"doc":"Returns an empty SchemaResult .","ref":"JsonSchema.Parser.SchemaResult.html#new/0","title":"JsonSchema.Parser.SchemaResult.new/0","type":"function"},{"doc":"Constructs a new SchemaResult . A SchemaResult consists of a schema dictionary corresponding to the succesfully parsed JSON schema files, and a list of warnings and errors encountered while parsing.","ref":"JsonSchema.Parser.SchemaResult.html#new/3","title":"JsonSchema.Parser.SchemaResult.new/3","type":"function"},{"doc":"","ref":"JsonSchema.Parser.SchemaResult.html#t:t/0","title":"JsonSchema.Parser.SchemaResult.t/0","type":"type"},{"doc":"Parses a JSON schema array type: { &quot;type&quot; : &quot;array&quot; , &quot;items&quot; : [ { &quot;$ref&quot; : &quot;#/rectangle&quot; } , { &quot;$ref&quot; : &quot;#/circle&quot; } ] } Into a JsonSchema.Types.TupleType .","ref":"JsonSchema.Parser.TupleParser.html","title":"JsonSchema.Parser.TupleParser","type":"module"},{"doc":"Parses a JSON schema array type into an JsonSchema.Types.TupleType .","ref":"JsonSchema.Parser.TupleParser.html#parse/5","title":"JsonSchema.Parser.TupleParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents a tuple type. Examples iex&gt; type?(%{}) false iex&gt; aTuple = %{&quot;items&quot; =&gt; [%{&quot;$ref&quot; =&gt; &quot;#foo&quot;}, %{&quot;$ref&quot; =&gt; &quot;#bar&quot;}]} iex&gt; type?(aTuple) true","ref":"JsonSchema.Parser.TupleParser.html#type?/1","title":"JsonSchema.Parser.TupleParser.type?/1","type":"function"},{"doc":"Parses a JSON schema type reference: { &quot;$ref&quot; : &quot;#/definitions/link&quot; } Into an JsonSchema.Types.TypeReference .","ref":"JsonSchema.Parser.TypeReferenceParser.html","title":"JsonSchema.Parser.TypeReferenceParser","type":"module"},{"doc":"Parses a JSON schema type reference into an JsonSchema.Types.TypeReference .","ref":"JsonSchema.Parser.TypeReferenceParser.html#parse/5","title":"JsonSchema.Parser.TypeReferenceParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents a reference to another schema. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;$ref&quot; =&gt; &quot;#foo&quot;}) true","ref":"JsonSchema.Parser.TypeReferenceParser.html#type?/1","title":"JsonSchema.Parser.TypeReferenceParser.type?/1","type":"function"},{"doc":"Parses a JSON schema union type: { &quot;type&quot; : [ &quot;number&quot; , &quot;integer&quot; , &quot;null&quot; ] } Into an JsonSchema.Types.UnionType .","ref":"JsonSchema.Parser.UnionParser.html","title":"JsonSchema.Parser.UnionParser","type":"module"},{"doc":"Parses a JSON schema union type into an JsonSchema.Types.UnionType .","ref":"JsonSchema.Parser.UnionParser.html#parse/5","title":"JsonSchema.Parser.UnionParser.parse/5","type":"function"},{"doc":"Returns true if the json subschema represents a union type. Examples iex&gt; type?(%{}) false iex&gt; type?(%{&quot;type&quot; =&gt; [&quot;number&quot;, &quot;integer&quot;, &quot;string&quot;]}) true","ref":"JsonSchema.Parser.UnionParser.html#type?/1","title":"JsonSchema.Parser.UnionParser.type?/1","type":"function"},{"doc":"A module containing utility functions for JSON schema parsers.","ref":"JsonSchema.Parser.Util.html","title":"JsonSchema.Parser.Util","type":"module"},{"doc":"Adds a child to the fragment of a URI . Examples iex&gt; add_fragment_child ( % URI { ...&gt; authority : nil , ...&gt; fragment : &quot;/definitions/foo&quot; , ...&gt; host : nil , ...&gt; path : nil , ...&gt; port : nil , ...&gt; query : nil , ...&gt; scheme : nil , ...&gt; userinfo : nil ...&gt; } , &quot;bar&quot; ) % URI { authority : nil , fragment : &quot;/definitions/foo/bar&quot; , host : nil , path : nil , port : nil , query : nil , scheme : nil , userinfo : nil }","ref":"JsonSchema.Parser.Util.html#add_fragment_child/2","title":"JsonSchema.Parser.Util.add_fragment_child/2","type":"function"},{"doc":"Creates a new type dictionary based on the given type definition and an optional ID.","ref":"JsonSchema.Parser.Util.html#create_type_dict/3","title":"JsonSchema.Parser.Util.create_type_dict/3","type":"function"},{"doc":"Returns a list of type paths when given a type dictionary.","ref":"JsonSchema.Parser.Util.html#create_types_list/2","title":"JsonSchema.Parser.Util.create_types_list/2","type":"function"},{"doc":"Parse a list of JSON schema objects that have a child relation to another schema object with the specified parent_id .","ref":"JsonSchema.Parser.Util.html#parse_child_types/3","title":"JsonSchema.Parser.Util.parse_child_types/3","type":"function"},{"doc":"Parses a node type.","ref":"JsonSchema.Parser.Util.html#parse_type/5","title":"JsonSchema.Parser.Util.parse_type/5","type":"function"},{"doc":"","ref":"JsonSchema.Parser.Util.html#t:nodeParser/0","title":"JsonSchema.Parser.Util.nodeParser/0","type":"type"},{"doc":"Module containing functions for resolving types. Main function being the resolve_type function.","ref":"JsonSchema.Resolver.html","title":"JsonSchema.Resolver","type":"module"},{"doc":"Resolves a type given its identifier , parent identifier of the resolving subschema, the subschema's enclosing SchemaDefinition and the schema dictionary of the whole set of parsed JSON schema files. { &quot;$schema&quot; : &quot;http://json-schema.org/draft-07/schema#&quot; , &quot;$id&quot; : &quot;http://example.com/circle.json&quot; , &quot;title&quot; : &quot;Circle&quot; , &quot;description&quot; : &quot;Schema for a circle shape&quot; , &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } , &quot;center&quot; : { &quot;$ref&quot; : &quot;http://example.com/definitions.json#point&quot; } , &quot;color&quot; : { &quot;$ref&quot; : &quot;http://example.com/definitions.json#color&quot; } } , &quot;required&quot; : [ &quot;center&quot; , &quot;radius&quot; ] }","ref":"JsonSchema.Resolver.html#resolve_type/4","title":"JsonSchema.Resolver.resolve_type/4","type":"function"},{"doc":"Specifies the main Elixir types used for describing the intermediate representations of JSON schema types.","ref":"JsonSchema.Types.html","title":"JsonSchema.Types","type":"module"},{"doc":"","ref":"JsonSchema.Types.html#t:json_value/0","title":"JsonSchema.Types.json_value/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:propertyDictionary/0","title":"JsonSchema.Types.propertyDictionary/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:schemaDictionary/0","title":"JsonSchema.Types.schemaDictionary/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:schemaNode/0","title":"JsonSchema.Types.schemaNode/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:typeDefinition/0","title":"JsonSchema.Types.typeDefinition/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:typeDictionary/0","title":"JsonSchema.Types.typeDictionary/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.html#t:typeIdentifier/0","title":"JsonSchema.Types.typeIdentifier/0","type":"type"},{"doc":"Represents a custom allOf type definition in a JSON schema. JSON Schema: The following example schema has the path &quot;#/definitions/fancyCircle&quot; { &quot;description&quot; : &quot;A fancy circle&quot; , &quot;allOf&quot; : [ { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/definitions/color&quot; } , &quot;description&quot; : { &quot;type&quot; : &quot;string&quot; } } , &quot;required&quot; : [ &quot;color&quot; ] } , { &quot;$ref&quot; : &quot;#/definitions/circle&quot; } ] } where &quot;#/definitions/color&quot; resolves to: { &quot;type&quot; : &quot;string&quot; , &quot;enum&quot; : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; ] } and &quot;#/definitions/circle&quot; resolves to: { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;radius&quot; ] } Resulting in the Elixir representation: % AllOfType { name : &quot;fancyCircle&quot; , description : &quot;A fancy circle&quot; , path : URI . parse ( &quot;#/definitions/fancyCircle&quot; ) , types : [ URI . parse ( &quot;#/definitions/fancyCircle/allOf/0&quot; ) , URI . parse ( &quot;#/definitions/fancyCircle/allOf/1&quot; ) ] }","ref":"JsonSchema.Types.AllOfType.html","title":"JsonSchema.Types.AllOfType","type":"module"},{"doc":"","ref":"JsonSchema.Types.AllOfType.html#t:t/0","title":"JsonSchema.Types.AllOfType.t/0","type":"type"},{"doc":"Represents a custom anyOf type definition in a JSON schema. JSON Schema: The following example schema has the path &quot;#/definitions/fancyCircle&quot; { &quot;description&quot; : &quot;A fancy circle&quot; , &quot;anyOf&quot; : [ { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/definitions/color&quot; } , &quot;description&quot; : { &quot;type&quot; : &quot;string&quot; } } , &quot;required&quot; : [ &quot;color&quot; ] } , { &quot;$ref&quot; : &quot;#/definitions/circle&quot; } ] } where &quot;#/definitions/color&quot; resolves to: { &quot;type&quot; : &quot;string&quot; , &quot;enum&quot; : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; ] } and &quot;#/definitions/circle&quot; resolves to: { &quot;type&quot; : &quot;object&quot; , &quot;properties&quot; : { &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;required&quot; : [ &quot;radius&quot; ] } Resulting in the Elixir representation: % AnyOfType { name : &quot;fancyCircle&quot; , description : &quot;A fancy circle&quot; , path : URI . parse ( &quot;#/definitions/fancyCircle&quot; ) , types : [ URI . parse ( &quot;#/definitions/fancyCircle/allOf/0&quot; ) , URI . parse ( &quot;#/definitions/fancyCircle/allOf/1&quot; ) ] }","ref":"JsonSchema.Types.AnyOfType.html","title":"JsonSchema.Types.AnyOfType","type":"module"},{"doc":"","ref":"JsonSchema.Types.AnyOfType.html#t:t/0","title":"JsonSchema.Types.AnyOfType.t/0","type":"type"},{"doc":"Represents a custom array type definition in a JSON schema. JSON Schema: &quot;rectangles&quot; : { &quot;description&quot; : &quot;A list of rectangles&quot; , &quot;type&quot; : &quot;array&quot; , &quot;items&quot; : { &quot;$ref&quot; : &quot;#/rectangle&quot; } } Resulting in the Elixir representation: % ArrayType { name : &quot;rectangles&quot; , description : &quot;A list of rectangles&quot; , path : URI . parse ( &quot;#/rectangles&quot; ) , items : URI . parse ( &quot;#/rectangles/items&quot; ) }","ref":"JsonSchema.Types.ArrayType.html","title":"JsonSchema.Types.ArrayType","type":"module"},{"doc":"","ref":"JsonSchema.Types.ArrayType.html#t:t/0","title":"JsonSchema.Types.ArrayType.t/0","type":"type"},{"doc":"Represents a custom const type definition in a JSON schema. JSON Schema: &quot;favoriteNumber&quot; : { &quot;type&quot; : &quot;integer&quot; , &quot;const&quot; : 42 } or &quot;testStruct&quot; : { &quot;const&quot; : { &quot;name&quot; : &quot;Test&quot; , &quot;foo&quot; : 43 } } Resulting in the Elixir representation: % ConstType { name : &quot;favoriteNumber&quot; , description : nil , type : :number , path : URI . parse ( &quot;#/favoriteNumber&quot; ) , const : 42 } or % ConstType { name : &quot;testStruct&quot; , description : nil , type : :object , path : URI . parse ( &quot;#/testStruct&quot; ) , const : %{ &quot;name&quot; =&gt; &quot;Test&quot; , &quot;foo&quot; =&gt; 43 } }","ref":"JsonSchema.Types.ConstType.html","title":"JsonSchema.Types.ConstType","type":"module"},{"doc":"","ref":"JsonSchema.Types.ConstType.html#t:t/0","title":"JsonSchema.Types.ConstType.t/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.ConstType.html#t:value/0","title":"JsonSchema.Types.ConstType.value/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.ConstType.html#t:value_type/0","title":"JsonSchema.Types.ConstType.value_type/0","type":"type"},{"doc":"Represents a custom enum type definition in a JSON schema. JSON Schema: &quot;color&quot; : { &quot;description&quot; : &quot;A set of colors&quot; , &quot;type&quot; : &quot;string&quot; , &quot;enum&quot; : [ &quot;none&quot; , &quot;green&quot; , &quot;orange&quot; , &quot;blue&quot; , &quot;yellow&quot; , &quot;red&quot; ] } Resulting in the Elixir representation: % EnumType { name : &quot;color&quot; , description : &quot;A set of colors&quot; , path : URI . parse ( &quot;#/color&quot; ) , type : &quot;string&quot; , values : [ &quot;none&quot; , &quot;green&quot; , &quot;orange&quot; , &quot;blue&quot; , &quot;yellow&quot; , &quot;red&quot; ] }","ref":"JsonSchema.Types.EnumType.html","title":"JsonSchema.Types.EnumType","type":"module"},{"doc":"","ref":"JsonSchema.Types.EnumType.html#t:t/0","title":"JsonSchema.Types.EnumType.t/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.EnumType.html#t:value_type/0","title":"JsonSchema.Types.EnumType.value_type/0","type":"type"},{"doc":"Represents a custom object type definition in a JSON schema. JSON Schema: &quot;circle&quot; : { &quot;type&quot; : &quot;object&quot; , &quot;description&quot; : &quot;A circle object&quot; , &quot;properties&quot; : { &quot;color&quot; : { &quot;$ref&quot; : &quot;#/color&quot; } , &quot;title&quot; : { &quot;type&quot; : &quot;string&quot; } , &quot;radius&quot; : { &quot;type&quot; : &quot;number&quot; } } , &quot;patternProperties&quot; : { &quot;f.*o&quot; : { &quot;type&quot; : &quot;integer&quot; } } , &quot;additionalProperties&quot; : { &quot;type&quot; : &quot;boolean&quot; } , &quot;required&quot; : [ &quot;color&quot; , &quot;radius&quot; ] } Resulting in the Elixir representation: % ObjectType { name : &quot;circle&quot; , description : &quot;A circle object&quot; , path : URI . parse ( &quot;#/circle&quot; ) , required : [ &quot;color&quot; , &quot;radius&quot; ] , properties : %{ &quot;color&quot; =&gt; URI . parse ( &quot;#/circle/properties/color&quot; ) , &quot;title&quot; =&gt; URI . parse ( &quot;#/circle/properties/title&quot; ) , &quot;radius&quot; =&gt; URI . parse ( &quot;#/circle/properties/radius&quot; ) } , pattern_properties : %{ &quot;f.*o&quot; =&gt; URI . parse ( &quot;#/circle/patternProperties/f.*o&quot; ) } , additional_properties : URI . parse ( &quot;#/circle/additionalProperties&quot; )","ref":"JsonSchema.Types.ObjectType.html","title":"JsonSchema.Types.ObjectType","type":"module"},{"doc":"","ref":"JsonSchema.Types.ObjectType.html#t:t/0","title":"JsonSchema.Types.ObjectType.t/0","type":"type"},{"doc":"Represents a custom oneOf type definition in a JSON schema. JSON Schema: &quot;shape&quot; : { &quot;description&quot; : &quot;A union type of shapes&quot; , &quot;oneOf&quot; : [ { &quot;$ref&quot; : &quot;#/definitions/circle&quot; } , { &quot;$ref&quot; : &quot;#/definitions/rectangle&quot; } ] } Resulting in the Elixir representation: % OneOfType { name : &quot;shape&quot; , description : &quot;A union type of shapes&quot; , path : URI . parse ( &quot;#/shape&quot; ) , types : [ URI . parse ( &quot;#/shape/oneOf/0&quot; ) , URI . parse ( &quot;#/shape/oneOf/1&quot; ) ] }","ref":"JsonSchema.Types.OneOfType.html","title":"JsonSchema.Types.OneOfType","type":"module"},{"doc":"","ref":"JsonSchema.Types.OneOfType.html#t:t/0","title":"JsonSchema.Types.OneOfType.t/0","type":"type"},{"doc":"Represents a custom primitive type definition in a JSON schema. JSON Schema: &quot;name&quot; : { &quot;description&quot; : &quot;A name&quot; , &quot;type&quot; : &quot;string&quot; } Resulting in the Elixir representation: % PrimitiveType { name : &quot;name&quot; , description : &quot;A name&quot; , path : URI . parse ( &quot;#/name&quot; ) , type : :string }","ref":"JsonSchema.Types.PrimitiveType.html","title":"JsonSchema.Types.PrimitiveType","type":"module"},{"doc":"","ref":"JsonSchema.Types.PrimitiveType.html#t:t/0","title":"JsonSchema.Types.PrimitiveType.t/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.PrimitiveType.html#t:value_type/0","title":"JsonSchema.Types.PrimitiveType.value_type/0","type":"type"},{"doc":"An intermediate representation of the root of a whole JSON schema document.","ref":"JsonSchema.Types.SchemaDefinition.html","title":"JsonSchema.Types.SchemaDefinition","type":"module"},{"doc":"","ref":"JsonSchema.Types.SchemaDefinition.html#t:t/0","title":"JsonSchema.Types.SchemaDefinition.t/0","type":"type"},{"doc":"Represents a custom tuple type definition in a JSON schema. JSON Schema: &quot;shapePair&quot; : { &quot;description&quot; : &quot;A choice of shape&quot; , &quot;type&quot; : &quot;array&quot; , &quot;items&quot; : [ { &quot;$ref&quot; : &quot;#/rectangle&quot; } , { &quot;$ref&quot; : &quot;#/circle&quot; } ] } Resulting in the Elixir representation: % TupleType { name : &quot;shapePair&quot; , description : &quot;A choice of shape&quot; , path : URI . parse ( &quot;#/rectangles&quot; ) , items : [ URI . parse ( &quot;#/shapePair/items/0&quot; ] , URI . parse ( &quot;#/shapePair/items/1&quot; ] }","ref":"JsonSchema.Types.TupleType.html","title":"JsonSchema.Types.TupleType","type":"module"},{"doc":"","ref":"JsonSchema.Types.TupleType.html#t:t/0","title":"JsonSchema.Types.TupleType.t/0","type":"type"},{"doc":"Represents a reference to a custom type definition in a JSON schema. JSON Schema: &quot;self&quot; : { &quot;$ref&quot; : &quot;#/definitions/foo&quot; } &quot;other&quot; : { &quot;$ref&quot; : &quot;http://www.example.com/definitions.json#bar&quot; } where &quot;#/definitions/foo&quot; resolves to &quot;definitions&quot; : { &quot;foo&quot; : { &quot;type&quot; : &quot;string&quot; } } and &quot; http://www.example.com/definitions.json#bar&quot; resolves to &quot;definitions&quot; : { &quot;bar&quot; : { &quot;id&quot; : &quot;#bar&quot; , &quot;type&quot; : &quot;number&quot; } } Resulting in the Elixir representation: % TypeReference { name : &quot;self&quot; , path : URI . parse ( &quot;#/definitions/foo&quot; ] } % TypeReference { name : &quot;other&quot; , path : URI . parse ( &quot;http://www.example.com/definitions.json#bar&quot; ) }","ref":"JsonSchema.Types.TypeReference.html","title":"JsonSchema.Types.TypeReference","type":"module"},{"doc":"","ref":"JsonSchema.Types.TypeReference.html#t:t/0","title":"JsonSchema.Types.TypeReference.t/0","type":"type"},{"doc":"Represents a custom union type definition in a JSON schema. JSON Schema: &quot;favoriteNumber&quot; : { &quot;description&quot; : &quot;Your favorite number&quot; , &quot;type&quot; : [ &quot;number&quot; , &quot;integer&quot; , &quot;null&quot; ] } Resulting in the Elixir representation: % UnionType { name : &quot;favoriteNumber&quot; , description : &quot;Your favorite number&quot; , path : URI . parse ( &quot;#/favoriteNumber&quot; ) , types : [ :number , :integer , :null ] }","ref":"JsonSchema.Types.UnionType.html","title":"JsonSchema.Types.UnionType","type":"module"},{"doc":"","ref":"JsonSchema.Types.UnionType.html#t:t/0","title":"JsonSchema.Types.UnionType.t/0","type":"type"},{"doc":"","ref":"JsonSchema.Types.UnionType.html#t:value_type/0","title":"JsonSchema.Types.UnionType.value_type/0","type":"type"},{"doc":"A JSON schema parser for inspection and manipulation of JSON Schema Abstract Syntax Trees (ASTs). This library is meant as a basis for writing other libraries or tools that need to use JSON schema documents. For example, a JSON schema validator that validates a JSON object according to a JSON schema specification, or a code generator that generates a data model and accompanying JSON serializers based on the JSON schema specification of an API -- the project JSON Schema to Elm is an example of such a tool.","ref":"readme.html","title":"JSON Schema","type":"extras"},{"doc":"Add :json_schema as a dependency in mix.exs : defp deps do [ { :json_schema , &quot;~&gt; 0.4&quot; } ] end","ref":"readme.html#installation","title":"JSON Schema - Installation","type":"extras"},{"doc":"The words type and subschema are used interchangeable in the rest of the document. The main API entry point is the JsonSchema module, which supports parsing a list of JSON schema files into JSON Schema ASTs via parse_schema_files , or resolving a JSON schema type given an identifier via resolve_type . Parsing a JSON schema file into an Abstract Syntax Tree Presuming we have the following two JSON schema files: { &quot;$schema&quot;: &quot;http://json-schema.org/draft-07/schema#&quot;, &quot;$id&quot;: &quot;http://example.com/circle.json&quot;, &quot;title&quot;: &quot;Circle&quot;, &quot;description&quot;: &quot;Schema for a circle shape&quot;, &quot;type&quot;: &quot;object&quot;, &quot;properties&quot;: { &quot;center&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#point&quot; }, &quot;radius&quot;: { &quot;type&quot;: &quot;number&quot; }, &quot;color&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#color&quot; } }, &quot;required&quot;: [&quot;center&quot;, &quot;radius&quot;] } and { &quot;$schema&quot;: &quot;http://json-schema.org/draft-07/schema#&quot;, &quot;title&quot;: &quot;Definitions&quot;, &quot;$id&quot;: &quot;http://example.com/definitions.json&quot;, &quot;description&quot;: &quot;Schema for common types&quot;, &quot;definitions&quot;: { &quot;color&quot;: { &quot;$id&quot;: &quot;#color&quot;, &quot;type&quot;: &quot;string&quot;, &quot;enum&quot;: [ &quot;red&quot;, &quot;yellow&quot;, &quot;green&quot;, &quot;blue&quot; ] }, &quot;point&quot;: { &quot;$id&quot;: &quot;#point&quot;, &quot;type&quot;: &quot;object&quot;, &quot;properties&quot;: { &quot;x&quot;: { &quot;type&quot;: &quot;number&quot; }, &quot;y&quot;: { &quot;type&quot;: &quot;number&quot; } }, &quot;required&quot;: [ &quot;x&quot;, &quot;y&quot; ] } } } we can parses the into a JSON schema AST by passing them to JsonSchema.parse_schema_files . This produces a SchemaResult containing a schema dictionary, schema_dict , and any errors or warnings generated along the way. schema_paths = [ &quot;./path/to/json_schemas/circle.json&quot; , &quot;./path/to/json_schemas/definitions.json&quot; ] schema_result = JsonSchema . parse_schema_files ( schema_paths ) % JsonSchema.Parser.SchemaResult { errors : [ ] , warnings : [ ] , schema_dict : %{ &quot;http://example.com/circle.json&quot; =&gt; % JsonSchema.Types.SchemaDefinition { description : &quot;Schema for a circle shape&quot; , file_path : &quot;/path/to/json-schemas/circle.json&quot; , id : URI . parse ( &quot;http://example.com/circle.json&quot; ) , title : &quot;Circle&quot; , types : %{ &quot;#&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : &quot;Schema for a circle shape&quot; , name : &quot;Circle&quot; , path : URI . parse ( &quot;#&quot; ) , pattern_properties : %{ } , properties : %{ &quot;center&quot; =&gt; URI . parse ( &quot;#/properties/center&quot; ) , &quot;color&quot; =&gt; URI . parse ( &quot;#/properties/color&quot; ) , &quot;radius&quot; =&gt; URI . parse ( &quot;#/properties/radius&quot; ) } , required : [ &quot;center&quot; , &quot;radius&quot; ] } , &quot;#/properties/center&quot; =&gt; % JsonSchema.Types.TypeReference { name : &quot;center&quot; , path : URI . parse ( &quot;http://example.com/definitions.json#point&quot; ) } , &quot;#/properties/color&quot; =&gt; % JsonSchema.Types.TypeReference { name : &quot;color&quot; , path : URI . parse ( &quot;http://example.com/definitions.json#color&quot; ) } , &quot;#/properties/radius&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;radius&quot; , path : URI . parse ( &quot;#/properties/radius), type: :number }, &quot; http :// example . com / circle . json #&quot; =&gt; %JsonSchema.Types.ObjectType{ additional_properties : nil , description : &quot;Schema for a circle shape&quot; , name : &quot;Circle&quot; , path : URI . parse ( &quot;#&quot; ) , pattern_properties : %{ } , properties : %{ &quot;center&quot; =&gt; URI . parse ( &quot;#/properties/center&quot; ) , &quot;color&quot; =&gt; URI . parse ( &quot;#/properties/color&quot; ) , &quot;radius&quot; =&gt; URI . parse ( &quot;#/properties/radius&quot; ) } , required : [ &quot;center&quot; , &quot;radius&quot; ] } } } , &quot;http://example.com/definitions.json&quot; =&gt; % JsonSchema.Types.SchemaDefinition { description : &quot;Schema for common types&quot; , file_path : &quot;/path/to/json-schemas/definitions.json&quot; , id : URI . parse ( &quot;http://example.com/definitions.json&quot; ) , title : &quot;Definitions&quot; , types : %{ &quot;#/definitions/color&quot; =&gt; % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] } , &quot;#/definitions/point&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : nil , name : &quot;point&quot; , path : URI . parse ( &quot;#/definitions/point&quot; ) , pattern_properties : %{ } , properties : %{ &quot;x&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/x&quot; ) , &quot;y&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/y&quot; ) } , required : [ &quot;x&quot; , &quot;y&quot; ] } , &quot;#/definitions/point/properties/x&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;x&quot; , path : URI . parse ( &quot;/definitions/point/properties/x&quot; ) , type : :number } , &quot;#/definitions/point/properties/y&quot; =&gt; % JsonSchema.Types.PrimitiveType { description : nil , name : &quot;y&quot; , path : URI . parse ( &quot;#/definitions/point/properties/y&quot; ) , type : :number } , &quot;http://example.com/definitions.json#color&quot; =&gt; % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] } , &quot;http://example.com/definitions.json#point&quot; =&gt; % JsonSchema.Types.ObjectType { additional_properties : nil , description : nil , name : &quot;point&quot; , path : URI . parse ( &quot;#/definitions/point&quot; ) , pattern_properties : %{ } , properties : %{ &quot;x&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/x&quot; ) , &quot;y&quot; =&gt; URI . parse ( &quot;#/definitions/point/properties/y&quot; ) } , required : [ &quot;x&quot; , &quot;y&quot; ] } } } } } The schema dictionary uses the schema ID ( URI ) as key and the parsed schema as value. Each parsed schema likewise contains a type dictionary, types , which uses the subschema path ( URI ) as key and the parsed subschema as value. If there are no errors in the schema result, the parsed schema dictionary can then be used in your own JSON schema tool as appropriate. Resolving a JSON Schema type from an identifier Using the example schema dictionary from the previous section, we can use the JsonSchema.resolve_type function to lookup a subschema associated contained the schema dictionary. The resolve_type function expects: the identifier of the subschema to lookup which can be either a fully qualified identifier like http://example.com/definitions.json#color , a relative identifier like #color , or a relative path like #/definitions/color when resolving a subschema inside the same parent schema. the parent identifier of the subschema doing the lookup, needed for relative lookups and better error messaging, the enclosing schema definition, schema_def , of the subschema doing the lookup, also needed for relative lookups and error messaging, the schema dictionary of the whole set of schemas. In the example below, we resolve the reference to color : &quot;color&quot;: { &quot;$ref&quot;: &quot;http://example.com/definitions.json#color&quot; } from the inside the circle subschema properties. schema_dict = schema_result . schema_dict schema_def = schema_dict [ &quot;http://example.com/circle.json&quot; ] parent = URI . parse ( &quot;#/properties&quot; ) identifier = URI . parse ( &quot;#/properties/color&quot; ) lookup_result = JsonSchema . resolve_type ( identifier , parent , schema_def , schema_dict ) { :ok , { color_type , parent_schema_def } } = lookup_result parent_schema_def == schema_dict [ &quot;http://example.com/circle.json&quot; ] color_type % JsonSchema.Types.EnumType { description : nil , name : &quot;color&quot; , path : URI . parse ( &quot;#/definitions/color&quot; ) , type : :string , values : [ &quot;red&quot; , &quot;yellow&quot; , &quot;green&quot; , &quot;blue&quot; ] }","ref":"readme.html#usage","title":"JSON Schema - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changed Replaces auto-generated schema names like zero and one with :anonymous making it easier for a consuming project to decide what to do when a subschema does not have an explicit name. (#97) Replaces stringly-typed type properties for several schema types to instead use specific atoms corresponding to the set of valid JSON value type. Adds better error description for invalid union types.","ref":"changelog.html#v0-4-0-2022-05-09","title":"Changelog - v0.4.0 [2022-05-09]","type":"extras"},{"doc":"Added Support for the generic description keyword (#14). support for the const keyword (#21). Fixed Various bugs related to parsing nested root object (#35).","ref":"changelog.html#v0-3-0-2019-10-30","title":"Changelog - v0.3.0 [2019-10-30]","type":"extras"},{"doc":"Added Support for parsing the following JSON schema types: additionalProperties , and patternProperties . Changed Replaced the TypePath type wih the URI type when specifying local paths in a JSON schema document.","ref":"changelog.html#v0-2-0-2019-03-24","title":"Changelog - v0.2.0 [2019-03-24]","type":"extras"},{"doc":"NOTE: This initial release is a fork of https://github.com/dragonwasrobot/json-schema-to-elm , and so this version contains all existing changes made in that project. As a result, the parser and inspection logic found in this first version reflects which parts of the JSON Schema specification was needed in the original project. Added Support for parsing the following JSON schema types: allOf , anyOf , array (keyword items when value is a object), enum , object , (keyword properties ), oneOf , primitive (keyword type except for object and array ), tuple (keyword items when value is a list of objects), and union (keyword type when value is a list of strings). Parsing of the basic properties of a JSON schema document: schema , $id , $ref , title , description , &quot;definitions&quot; , and required . Can resolve references, using $ref , across different JSON schema files as long as they are parsed together. Prints human friendly error messages .","ref":"changelog.html#v0-1-0-2018-07-27","title":"Changelog - v0.1.0 [2018-07-27]","type":"extras"}]